package java.lang.management;

import sun.management.MonitorInfoCompositeData;
import javax.management.openmbean.CompositeData;

public class MonitorInfo extends LockInfo
{
    private int stackDepth;
    private StackTraceElement stackFrame;
    
    public MonitorInfo(String s, int n, int i, StackTraceElement stackFrame) {
        super(s, n);
        if (i >= 0 && stackFrame == null) {
            throw new IllegalArgumentException("Parameter stackDepth is " + i + " but stackFrame is null");
        }
        if (i < 0 && stackFrame != null) {
            throw new IllegalArgumentException("Parameter stackDepth is " + i + " but stackFrame is not null");
        }
        this.stackDepth = i;
        this.stackFrame = stackFrame;
        return;
    }
    
    public int getLockedStackDepth() {
        return this.stackDepth;
    }
    
    public StackTraceElement getLockedStackFrame() {
        return this.stackFrame;
    }
    
    public static MonitorInfo from(CompositeData cd) {
        if (cd == null) {
            return null;
        }
        if ((cd instanceof MonitorInfoCompositeData)) {
            return ((MonitorInfoCompositeData)cd).getMonitorInfo();
        }
        MonitorInfoCompositeData.validateCompositeData(cd);
        return new MonitorInfo(MonitorInfoCompositeData.getClassName(cd), MonitorInfoCompositeData.getIdentityHashCode(cd), MonitorInfoCompositeData.getLockedStackDepth(cd), MonitorInfoCompositeData.getLockedStackFrame(cd));
    }
}
